function A=recover_A(sigmaa,gv,hv,bv,z,w);
% recovers matrix A from its quasiseparable generators
% (optimal or redundant)

N=length(z);  % matrix size
A=zeros(N);

% fill subdiagonal:
for k=1:N-1
    A(k+1,k)=sigmaa(k);
end

% fill upper triangular part:
for j=1:N-1  % fill each row
    x=gv(j,:);
    for k=j:N-1
        A(j,k)=x*hv(:,k)-z(j)*w(k)';
        x=x*bv(:,:,k);
    end
    A(j,N)=x*hv(:,N)-z(j)*w(N)';
end
A(N,N)=gv(N,:)*hv(:,N)-z(N)*w(N)';